package br.ufsc.uid2uml.UIDElements;


/**
 * @author Patricia Vilain
 */
public class TransitionFromSet extends Transition {
	
	int numberOfSelectedElements;
		
	/** Cria uma transicao que possui como destino um estado de interacao.
	 * O numero de elementos selecionados e' 1.
	 */
	public TransitionFromSet (String id, Object source, AbstractState targetState){
		super (id, source, targetState);
		this.numberOfSelectedElements = 1;
	}

	/** Cria uma transicao que possui como destino a chamada de outro UID.
	 * O numero de elementos selecionados e' 1.
	 */
	public TransitionFromSet (String id, Object source, String nameTargetUID){
		super (id, source, nameTargetUID);
		this.numberOfSelectedElements = 1;
	}

	public int getNumberOfSelectedElements() {
		return numberOfSelectedElements;
	}

	public void setNumberOfSelectedElements(int numberOfSelectedElements) {
		this.numberOfSelectedElements = numberOfSelectedElements;
	}
}
